| OpenCV 4.3.0 Open Source Computer Vision

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
cv::LDA Class Reference
Core functionality » Operations on arrays

Linear Discriminant Analysis. More...

`#include <opencv2/core.hpp>`

## Public Member Functions
| LDA (int num_components=0)
| constructor Initializes a LDA with num_components (default 0). More...
| LDA (InputArrayOfArrays src, InputArray labels, int num_components=0)
| ~LDA ()
void | compute (InputArrayOfArrays src, InputArray labels)
Mat | eigenvalues () const
Mat | eigenvectors () const
void | load (const String &filename)
void | load (const FileStorage &node)
Mat | project (InputArray src)
Mat | reconstruct (InputArray src)
void | save (const String &filename) const
void | save (FileStorage &fs) const

## Static Public Member Functions
static Mat | subspaceProject (InputArray W, InputArray mean, InputArray src)
static Mat | subspaceReconstruct (InputArray W, InputArray mean, InputArray src)

## Protected Member Functions
void | lda (InputArrayOfArrays src, InputArray labels)

## Protected Attributes
Mat | _eigenvalues
Mat | _eigenvectors
int | _num_components

## Detailed Description

Linear Discriminant Analysis.

Todo:
  document this class

## Constructor & Destructor Documentation

## ◆ LDA() [1/2]

cv::LDA::LDA | ( | int | num_components = `0` | ) |
| explicit

constructor Initializes a LDA with num_components (default 0).

## ◆ LDA() [2/2]

cv::LDA::LDA | ( | InputArrayOfArrays | src,
|  | InputArray | labels,
|  | int | num_components = `0`
| ) |  |

Initializes and performs a Discriminant Analysis with Fisher's Optimization Criterion on given data in src and corresponding labels in labels. If 0 (or less) number of components are given, they are automatically determined for given data in computation.

## ◆ ~LDA()

cv::LDA::~LDA | ( |  | ) |

destructor

## Member Function Documentation

## ◆ compute()

void cv::LDA::compute | ( | InputArrayOfArrays | src,
|  | InputArray | labels
| ) |  |

Compute the discriminants for data in src (row aligned) and labels.

## ◆ eigenvalues()

Mat cv::LDA::eigenvalues | ( |  | ) | const
| inline

Returns the eigenvalues of this LDA.

## ◆ eigenvectors()

Mat cv::LDA::eigenvectors | ( |  | ) | const
| inline

Returns the eigenvectors of this LDA.

## ◆ lda()

void cv::LDA::lda | ( | InputArrayOfArrays | src,
|  | InputArray | labels
| ) |  |
| protected

## ◆ load() [1/2]

void cv::LDA::load | ( | const String & | filename | ) |

Deserializes this object from a given filename.

## ◆ load() [2/2]

void cv::LDA::load | ( | const FileStorage & | node | ) |

Deserializes this object from a given cv::FileStorage.

## ◆ project()

Mat cv::LDA::project | ( | InputArray | src | ) |

Projects samples into the LDA subspace. src may be one or more row aligned samples.

## ◆ reconstruct()

Mat cv::LDA::reconstruct | ( | InputArray | src | ) |

Reconstructs projections from the LDA subspace. src may be one or more row aligned projections.

## ◆ save() [1/2]

void cv::LDA::save | ( | const String & | filename | ) | const

Serializes this object to a given filename.

## ◆ save() [2/2]

void cv::LDA::save | ( | FileStorage & | fs | ) | const

Serializes this object to a given cv::FileStorage.

## ◆ subspaceProject()

static Mat cv::LDA::subspaceProject | ( | InputArray | W,
|  | InputArray | mean,
|  | InputArray | src
| ) |  |
| static

## ◆ subspaceReconstruct()

static Mat cv::LDA::subspaceReconstruct | ( | InputArray | W,
|  | InputArray | mean,
|  | InputArray | src
| ) |  |
| static

## Member Data Documentation

## ◆ _eigenvalues

Mat cv::LDA::_eigenvalues
| protected

## ◆ _eigenvectors

Mat cv::LDA::_eigenvectors
| protected

## ◆ _num_components

int cv::LDA::_num_components
| protected

The documentation for this class was generated from the following file:

- opencv2/core.hpp